#!/opt/SPECTRUM/bin/perl 
 
# bobh
#
#2/12/2016 - from cancel reload with aristaSSH's ssh code.  an actual HACK!
 
# This script will initiate the perform the reload of a Cisco device.  (derived from "cancel-reload")
#
# Error Codes:
#   0   = Success
#   255 = Usage error
#   254 = Invalid timeout value
#   252 = Connection error
#   251 = Login error
#   249 = Enable error
#   253 = Unexpected results
#
 
use strict;
use warnings;
#- mod for SSH (do not use telnet)
use Net::SSH::Expect;

my $outputString="NO ERROR";
my $exitStatus = 0;
 
#open STDOUT, "> c:\\output.txt";

#- declare sub before calling (with -w perl arg)
sub reloadDevice($$$$$$$$$) {
    my $deviceIP=shift;
    my $user=shift;
    my $pass=shift;
    my $epass=shift;
## print "user,pass,epas: $user,$pass,$epass\n";
 
    my $reload_params=shift;
## print "reload param: $reload_params\n";
 
    my $login_timeout=shift;
    my $write_timeout=shift;
    my $statusSRef = shift;     # Exit status: 0 is good, anything else should match errors at beginning of this file
    my $resultSRef = shift;     # Reference to string containing results to be printed
 
    my @config;
    my $msg;
 
    $$statusSRef = 0;   # Let's be optimistic, 0 is good
    $$resultSRef = "";  # Same here
 
    #print "login_timeout=$login_timeout\n" ;
    ## print "attempt login... \n" ;
 
      my $ssh = Net::SSH::Expect->new ( host => $deviceIP,
                                        user => $user,
                                        password=> $pass,
                                        raw_pty => 1,
                                        no_terminal => 0,
                                        timeout => $login_timeout
                                      );
  
      my $login_output;
      eval { $login_output = $ssh->login(); };
## print "right after login, output: $login_output\n\n";
 
      if( $@ )
      {
          $msg = "Login has failed. Output: $login_output";
          #return( 252, $msg );
          $$statusSRef = 252;   # 
          $$resultSRef = $msg;  # 
 
      }
  
      # login output should contain the right prompt characters
      if( $login_output !~ /[\#\>]\s*\z/ )
      {
          $msg = "Login has failed. Didn't see device prompt as expected.";
          $ssh->close();
          #return( 252, $msg );
          $$statusSRef = 252;   # 
          $$resultSRef = $msg;  # 
 
          }
# jb
#
#3/13/2015
#
# modified IO for SSH over orig telnet
#
# they seem to have buffer timeout problems
#
      $ssh->send( "\r\n" );
      $login_output = $ssh->exec( "enable" );
      #$ssh->send( "\r\n" );
      $ssh->waitfor('[Pp]assword:\s*',10);
      $ssh->send($epass);
      $login_output = $ssh->exec("\r\n");
      $ssh->timeout( $login_timeout );
 
## print "logged in and enabled- output: $login_output\n"; 
 
      if( $login_output !~ /\#\s*\z/ )  # Replace '#' is the prompt character here
      {
    #        we don't have the '#' prompt, means we still can't exec commands
           $msg = "Exec prompt not found.";
           $ssh->close();
           #return( 249, $msg );
           $$statusSRef = 249;  # 
           $$resultSRef = $msg; # 
 
      }
  
 
     #-  now that we have ssh'd in (no longer using telnet) we need do what we came here for, reload | cancel reload
     #-   comments suggest that "cancel" is a parameter, 
     #-   and has to be configured in this script config for this device family 
 
## print "loginoutput: $login_output\n";
## print "reload param: $reload_params\n";
 
    #  Issue the reload command with any extra parameters, for Cisco this is 'cancel' (to cancel pending reload)
    my $reload_command = "reload " . $reload_params;
 
 
    #- need logic here: if reload we're done, but if cancel, we continue;
    #-- of cancel, then look for prommpt after 'reload cancel'
   
        if ($reload_params eq 'cancel') {
                $ssh->send($reload_command);
## print "after RELOAD CMD, waiting for confirmation prompt\n";
                if ( !($ssh->waitfor('.*SHUTDOWN ABORTED .*', $login_timeout,'-re'))) {
                        $msg= "Cancel Reload Failed.";
                        $ssh->close();
                        #$return( 253, $msg );
                        $$statusSRef = 253;     # 
                        $$resultSRef = $msg;    # 
                }
                else {
                # do we need a sleep n here?
                        my $reload_out = $ssh->exec("\r\n");
                        $msg="Reload Canceled.";
                        #$return (0, $msg);
                        $$statusSRef = 0;       # 
                        $$resultSRef = $msg;    # 
 
                }
        } 
        # param is NOT cancel, so this is a Reload (now or at)
        else {
## print "RELOADING WITH reload cmd: $reload_command\n"; 
                my $reload_out=$ssh->exec($reload_command);
## print "after RELOAD CMD, reload output: $reload_out\n";
                $ssh->waitfor("Proceed with reload? [confirm]",$login_timeout,'-ex'); # needs an "enter" to confirm
                #- send confirm carriage return
                $ssh->send( "\r\n" );
## print "after sending the cr, reload output: $reload_out\n";
                if ( !($ssh->waitfor('.*SHUTDOWN .*', $login_timeout,'-re'))) {
                    $msg= "Reload Failed.";
                    $$statusSRef = 253;     #
                    $$resultSRef = $msg;    #
                    $ssh->close();
 
                }  #- a successful "relaod" command is "fatal", no?
         $ssh->close();
        }
} #- end sub

### Main ###
if( $#ARGV != 6 && $#ARGV != 7 )
{
    print "Usage: CancelReload.pl <device IP> <user> <pass> <enable_pass> 
<reload_params> <login_timeout_in_seconds> <write_timeout_in_seconds>\n";
    print STDERR "Usage: CancelReload.pl <deviceIP> <user> <pass> 
<enable_pass> <reload_params> <login_timeout_in_seconds> 
<write_timeout_in_seconds>\n";
    exit 255;
}
elsif( $ARGV[5] < 1 || $ARGV[5] > 600 )
{
    print "$ARGV[5] is the login timeout and must be an int between 1 and 600 
seconds\n";
    print STDERR "$ARGV[5] is the login timeout and must be an int between 1 
and 600 seconds\n";
    exit 254;
}
elsif( $#ARGV == 6 && ( $ARGV[6] < 1 || $ARGV[6] > 600 ) )
{
    print "$ARGV[6] is the write timeout and must be an int between 1 and 600 
seconds\n";
    print STDERR "$ARGV[6] is the write timeout and must be an int between 1 
and 600 seconds\n";
    exit 254;
}
else
{
 
    ## print "argv[0]=$ARGV[0]\n" ;
    ## print "argv[1]=$ARGV[1]\n" ;
    ## print "argv[2]=$ARGV[2]\n" ;
    ## print "argv[3]=$ARGV[3]\n" ;
    ## print "argv[4]=$ARGV[4]\n" ;
    ## print "argv[5]=$ARGV[5]\n" ;
    ## print "argv[6]=$ARGV[6]\n" ;

## arg7,8 are errMsg and errCode!
 
    $ARGV[4]=~s/\'//g;
    ## print "argv[4] modified=$ARGV[4]\n" ;
    
    &reloadDevice( $ARGV[0], $ARGV[1], $ARGV[2],
                                             $ARGV[3], $ARGV[4], $ARGV[5],
                                             $ARGV[6], \$outputString, \$exitStatus);

    # Print the results 
    print "$outputString\n";

    # Print to standard error if status <> 0
    print STDERR "$outputString\n" if ($exitStatus > 0);
}
 
# Exit with the exit status
exit $exitStatus;
